### Hierarchy

- Controller

## Index

### Properties

- active
- attributes
- closeAfterSave
- confirmDeferred_
- createActive
- createToolActivate
- dirty
- editableNode_
- editableTreeCtrl
- editableWMSLayer_
- element_
- feature
- featureId
- features
- geomListenerKeys_
- geomType
- gettextCatalog_
- gmfEditFeature_
- gmfSnapping_
- gmfXSDAttributes_
- highlightVectorLayer_
- highlightedFeatures_
- hightlightedFeatures_
- interactions_
- listenerKeys_
- map
- mapListenerKeys_
- mapSelectActive
- mapSelectToolActivate
- menuMultipleListenerKeys_
- menuMultiple_
- menuVertex_
- menu_
- modifyToolActivate
- modify_
- ngeoEventHelper_
- ngeoFeatureHelper_
- ngeoLayerHelper_
- ngeoToolActivateMgr_
- options_
- pending
- q_
- rotateToolActivate
- rotate_
- scope_
- serverErrorMessage
- serverErrorType
- showServerError
- state
- timeout_
- tolerance
- translateToolActivate
- translate_
- unsavedModificationsModalShown
- vectorLayer
- vertexInfo_

### Methods

- $onInit
- cancel
- checkForModifications_
- confirmCancel
- continueWithoutSaving
- delete
- handleDestroy_
- handleEditFeature_
- handleFeatureAdd_
- handleFeatureChange_
- handleFeatureGeometryChange_
- handleFeaturePropertyChange_
- handleGetFeatures_
- handleMapClick_
- handleMapContextMenu_
- handleMapSelectActiveChange_
- handleMenuActionClick_
- handleMenuMultipleActionClick_
- handleMenuVertexActionClick_
- handleMultiMenuActionMouseEnter_
- handleMultiMenuActionMouseOut_
- handleRotateEnd_
- handleTranslateEnd_
- initializeInteractions_
- openFeatureMenu_
- registerInteractions_
- save
- setAttributes_
- setFeature_
- submit
- toggle_
- unregisterInteractions_

## Properties

### active

active: boolean

- Defined in src/editing/editFeatureComponent.js:392

### attributes

attributes: Attribute[]

- Defined in src/editing/editFeatureComponent.js:535

### closeAfterSave

closeAfterSave: boolean

- Defined in src/editing/editFeatureComponent.js:291

export

### confirmDeferred_

confirmDeferred_: IDeferred<never>

- Defined in src/editing/editFeatureComponent.js:373

A deferred object resolved after the confirm modal "continue w/o saving" or "save" buttons are clicked.

### createActive

createActive: boolean

- Defined in src/editing/editFeatureComponent.js:397

### createToolActivate

createToolActivate: default

- Defined in src/editing/editFeatureComponent.js:402

### dirty

dirty: boolean

- Defined in src/editing/editFeatureComponent.js:257

Flag that is toggled as soon as the feature changes, i.e. if any of its properties change, which includes the geometry.

### editableNode_

editableNode_: any

- Defined in src/editing/editFeatureComponent.js:360

### editableTreeCtrl

editableTreeCtrl: LayertreeController

- Defined in src/editing/editFeatureComponent.js:262

### editableWMSLayer_

editableWMSLayer_: TileLayer<TileSource> | ImageLayer<ImageSource>

- Defined in src/editing/editFeatureComponent.js:365

### element_

element_: JQuery<HTMLElement>

- Defined in src/editing/editFeatureComponent.js:298

### feature

feature: Feature<Geometry>

- Defined in src/editing/editFeatureComponent.js:417

### featureId

featureId: string | number

- Defined in src/editing/editFeatureComponent.js:424

### features

features: Collection<Feature<Geometry>>

- Defined in src/editing/editFeatureComponent.js:429

### geomListenerKeys_

geomListenerKeys_: EventsKey[]

- Defined in src/editing/editFeatureComponent.js:520

### geomType

geomType: string

- Defined in src/editing/editFeatureComponent.js:540

### gettextCatalog_

gettextCatalog_: gettextCatalog

- Defined in src/editing/editFeatureComponent.js:318

### gmfEditFeature_

gmfEditFeature_: any

- Defined in src/editing/editFeatureComponent.js:323

### gmfSnapping_

gmfSnapping_: any

- Defined in src/editing/editFeatureComponent.js:328

### gmfXSDAttributes_

gmfXSDAttributes_: any

- Defined in src/editing/editFeatureComponent.js:333

### highlightVectorLayer_

highlightVectorLayer_: VectorLayer<VectorSource<Geometry>>

- Defined in src/editing/editFeatureComponent.js:434

### highlightedFeatures_

highlightedFeatures_: Collection<Feature<Geometry>>

- Defined in src/editing/editFeatureComponent.js:439

### hightlightedFeatures_

hightlightedFeatures_: Collection<Feature<Geometry>>

- Defined in src/editing/editFeatureComponent.js:587

### interactions_

interactions_: Collection<Interaction>

- Defined in src/editing/editFeatureComponent.js:444

### listenerKeys_

listenerKeys_: EventsKey[]

- Defined in src/editing/editFeatureComponent.js:515

### map

map: Map

- Defined in src/editing/editFeatureComponent.js:267

### mapListenerKeys_

mapListenerKeys_: EventsKey[]

- Defined in src/editing/editFeatureComponent.js:525

### mapSelectActive

mapSelectActive: boolean

- Defined in src/editing/editFeatureComponent.js:407

### mapSelectToolActivate

mapSelectToolActivate: default

- Defined in src/editing/editFeatureComponent.js:412

### menuMultipleListenerKeys_

menuMultipleListenerKeys_: EventsKey[]

- Defined in src/editing/editFeatureComponent.js:530

### menuMultiple_

menuMultiple_: any

- Defined in src/editing/editFeatureComponent.js:490

### menuVertex_

menuVertex_: default

- Defined in src/editing/editFeatureComponent.js:477

### menu_

menu_: default

- Defined in src/editing/editFeatureComponent.js:459

### modifyToolActivate

modifyToolActivate: default

- Defined in src/editing/editFeatureComponent.js:454

### modify_

modify_: Modify

- Defined in src/editing/editFeatureComponent.js:449

### ngeoEventHelper_

ngeoEventHelper_: EventHelper

- Defined in src/editing/editFeatureComponent.js:338

### ngeoFeatureHelper_

ngeoFeatureHelper_: FeatureHelper

- Defined in src/editing/editFeatureComponent.js:343

### ngeoLayerHelper_

ngeoLayerHelper_: LayerHelper

- Defined in src/editing/editFeatureComponent.js:348

### ngeoToolActivateMgr_

ngeoToolActivateMgr_: ToolActivateMgr

- Defined in src/editing/editFeatureComponent.js:353

### options_

options_: any

- Defined in src/editing/editFeatureComponent.js:565

### pending

pending: boolean

- Defined in src/editing/editFeatureComponent.js:387

Flag that is toggled while a request is pending, either one to get features when a map is clicked or when saving

### q_

q_: IQService

- Defined in src/editing/editFeatureComponent.js:303

### rotateToolActivate

rotateToolActivate: default

- Defined in src/editing/editFeatureComponent.js:505

### rotate_

rotate_: default

- Defined in src/editing/editFeatureComponent.js:500

### scope_

scope_: IScope

- Defined in src/editing/editFeatureComponent.js:308

### serverErrorMessage

serverErrorMessage: string

- Defined in src/editing/editFeatureComponent.js:550

### serverErrorType

serverErrorType: string

- Defined in src/editing/editFeatureComponent.js:555

### showServerError

showServerError: boolean

- Defined in src/editing/editFeatureComponent.js:545

### state

state: string

- Defined in src/editing/editFeatureComponent.js:275

The state property shared with the `gmf-editfeatureselector` directive. For more info, see in that directive.

### timeout_

timeout_: ITimeoutService

- Defined in src/editing/editFeatureComponent.js:313

### tolerance

tolerance: number

- Defined in src/editing/editFeatureComponent.js:280

### translateToolActivate

translateToolActivate: default

- Defined in src/editing/editFeatureComponent.js:510

### translate_

translate_: default

- Defined in src/editing/editFeatureComponent.js:495

### unsavedModificationsModalShown

unsavedModificationsModalShown: boolean

- Defined in src/editing/editFeatureComponent.js:381

Flag that controls the visibility of the modal that manages unsaved modifications.

### vectorLayer

vectorLayer: VectorLayer<VectorSource<Geometry>>

- Defined in src/editing/editFeatureComponent.js:285

### vertexInfo_

vertexInfo_: number[]

- Defined in src/editing/editFeatureComponent.js:560

## Methods

### $onInit

- $onInit(): void

- - Defined in src/editing/editFeatureComponent.js:571

  Called on initialization of the controller.

  #### Returns void

### cancel

- cancel(): void

- - Defined in src/editing/editFeatureComponent.js:772

  #### Returns void

### checkForModifications_

- checkForModifications_(scopeApply: boolean): IPromise<void>

- - Defined in src/editing/editFeatureComponent.js:805

  Check if there's a feature selected and if it contains modifications (a.k.a. is dirty), then the confirmation modal is shown.

  #### Parameters

  - ##### scopeApply: boolean

  #### Returns IPromise<void>

  The promise attached to the confirm deferred object.

### confirmCancel

- confirmCancel(): IPromise<void>

- - Defined in src/editing/editFeatureComponent.js:790

  Check if there are unsaved modifications. If there aren't, then cancel. Used by the 'cancel' button in the template.

  #### Returns IPromise<void>

  The promise attached to the confirm deferred object.

### continueWithoutSaving

- continueWithoutSaving(): void

- - Defined in src/editing/editFeatureComponent.js:821

  #### Returns void

### delete

- delete(): void

- - Defined in src/editing/editFeatureComponent.js:831

  #### Returns void

### handleDestroy_

- handleDestroy_(): void

- - Defined in src/editing/editFeatureComponent.js:1463

  #### Returns void

### handleEditFeature_

- handleEditFeature_(resp: IHttpResponse<string | Node | Document | ArrayBuffer>): void

- - Defined in src/editing/editFeatureComponent.js:884

  Called after an insert, update or delete request.

  #### Parameters

  - ##### resp: IHttpResponse<string | Node | Document | ArrayBuffer>

    Ajax response.

  #### Returns void

### handleFeatureAdd_

- handleFeatureAdd_(evt: BaseEvent | Event): void

- - Defined in src/editing/editFeatureComponent.js:930

  #### Parameters

  - ##### evt: BaseEvent | Event

    Event.

  #### Returns void

### handleFeatureChange_

- handleFeatureChange_(newFeature: Feature<Geometry>, oldFeature: Feature<Geometry>): void

- - Defined in src/editing/editFeatureComponent.js:1349

  #### Parameters

  - ##### newFeature: Feature<Geometry>

    The new feature.

  - ##### oldFeature: Feature<Geometry>

    The old feature.

  #### Returns void

### handleFeatureGeometryChange_

- handleFeatureGeometryChange_(): void

- - Defined in src/editing/editFeatureComponent.js:1386

  #### Returns void

### handleFeaturePropertyChange_

- handleFeaturePropertyChange_(): void

- - Defined in src/editing/editFeatureComponent.js:1382

  #### Returns void

### handleGetFeatures_

- handleGetFeatures_(coordinate: number[], features: Feature<Geometry>[]): void

- - Defined in src/editing/editFeatureComponent.js:1241

  #### Parameters

  - ##### coordinate: number[]

    The click coordinates.

  - ##### features: Feature<Geometry>[]

    Features.

  #### Returns void

### handleMapClick_

- handleMapClick_(evt: BaseEvent | Event): void

- - Defined in src/editing/editFeatureComponent.js:1095

  Called when the map is clicked.

  (1) If a vector feature was clicked, don't do anything (i.e. allow the interactions to do their bidings without selecting a new feature).

  (2) Otherwise, if there is a feature being edited and has unsaved modifications, show the confirmation modal asking the user what to do about it.

  (3) If there's no feature selected or we have one without unsaved modifications or with modifications that were canceled, launch a query to fetch the features at the clicked location.

  #### Parameters

  - ##### evt: BaseEvent | Event

    Event.

  #### Returns void

### handleMapContextMenu_

- handleMapContextMenu_(evt: BaseEvent | Event): void

- - Defined in src/editing/editFeatureComponent.js:1166

  #### Parameters

  - ##### evt: BaseEvent | Event

    Event.

  #### Returns void

### handleMapSelectActiveChange_

- handleMapSelectActiveChange_(active: boolean): void

- - Defined in src/editing/editFeatureComponent.js:1059

  Called when the mapSelectActive property changes.

  #### Parameters

  - ##### active: boolean

    Whether the map select is active or not.

  #### Returns void

### handleMenuActionClick_

- handleMenuActionClick_(evt: BaseEvent | Event): void

- - Defined in src/editing/editFeatureComponent.js:1394

  #### Parameters

  - ##### evt: BaseEvent | Event

    Event.

  #### Returns void

### handleMenuMultipleActionClick_

- handleMenuMultipleActionClick_(features: Feature<Geometry>[], evt: BaseEvent | Event): void

- - Defined in src/editing/editFeatureComponent.js:1484

  Handles the click on element in the feature menu In the call the parameters are in inverse order!

  #### Parameters

  - ##### features: Feature<Geometry>[]

    Features.

  - ##### evt: BaseEvent | Event

    Event.

  #### Returns void

### handleMenuVertexActionClick_

- handleMenuVertexActionClick_(evt: BaseEvent | Event): void

- - Defined in src/editing/editFeatureComponent.js:1420

  #### Parameters

  - ##### evt: BaseEvent | Event

    Event.

  #### Returns void

### handleMultiMenuActionMouseEnter_

- handleMultiMenuActionMouseEnter_(features: Feature<Geometry>[], evt: BaseEvent | Event): void

- - Defined in src/editing/editFeatureComponent.js:1497

  Handles mouse entering a menu item of the multiple feature menu

  #### Parameters

  - ##### features: Feature<Geometry>[]

    Features.

  - ##### evt: BaseEvent | Event

    Event.

  #### Returns void

### handleMultiMenuActionMouseOut_

- handleMultiMenuActionMouseOut_(): void

- - Defined in src/editing/editFeatureComponent.js:1506

  Handles mouse leaving a menu item of the multiple feature menu

  #### Returns void

### handleRotateEnd_

- handleRotateEnd_(evt: BaseEvent | Event): void

- - Defined in src/editing/editFeatureComponent.js:1455

  #### Parameters

  - ##### evt: BaseEvent | Event

    Event.

  #### Returns void

### handleTranslateEnd_

- handleTranslateEnd_(evt: BaseEvent | Event): void

- - Defined in src/editing/editFeatureComponent.js:1444

  #### Parameters

  - ##### evt: BaseEvent | Event

    Event.

  #### Returns void

### initializeInteractions_

- initializeInteractions_(): void

- - Defined in src/editing/editFeatureComponent.js:1314

  Initialize interactions by setting them inactive and decorating them

  #### Returns void

### openFeatureMenu_

- openFeatureMenu_(coordinate: number[], features: Feature<Geometry>[]): void

- - Defined in src/editing/editFeatureComponent.js:1261

  #### Parameters

  - ##### coordinate: number[]

    The click coordinates.

  - ##### features: Feature<Geometry>[]

    Features.

  #### Returns void

### registerInteractions_

- registerInteractions_(): void

- - Defined in src/editing/editFeatureComponent.js:1324

  Register interactions by adding them to the map

  #### Returns void

### save

- save(): void

- - Defined in src/editing/editFeatureComponent.js:731

  Save the currently selected feature modifications.

  #### Returns void

### setAttributes_

- setAttributes_(attributes: Attribute[]): void

- - Defined in src/editing/editFeatureComponent.js:904

  #### Parameters

  - ##### attributes: Attribute[]

    Attributes.

  #### Returns void

### setFeature_

- setFeature_(feature: Feature<Geometry>): void

- - Defined in src/editing/editFeatureComponent.js:1232

  #### Parameters

  - ##### feature: Feature<Geometry>

    The feature to edit.

  #### Returns void

### submit

- submit(): void

- - Defined in src/editing/editFeatureComponent.js:871

  Called when the modal 'save' button is clicked. Do as if the user had clicked on the 'save' input button in the form, which allows the form to be validated.

  #### Returns void

### toggle_

- toggle_(active: boolean): void

- - Defined in src/editing/editFeatureComponent.js:985

  Activate or deactivate this directive.

  #### Parameters

  - ##### active: boolean

    Whether to activate this directive or not.

  #### Returns void

### unregisterInteractions_

- unregisterInteractions_(): void

- - Defined in src/editing/editFeatureComponent.js:1336

  Unregister interactions, i.e. set them inactive and remove them from the map

  #### Returns void

Generated using TypeDoc